/*
 * WebApiSegura Token JWT XrmAPI
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.CFirmante;
import io.swagger.client.model.CSeguimientoContratacionPortalAttributes;
import io.swagger.client.model.LDAPLoginRequest;
import io.swagger.client.model.LDAPUser;
import io.swagger.client.model.LoginRequest;
import io.swagger.client.BuildParameters;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LoginApi {
    private ApiClient apiClient;
	static final String APPJSON="application/json";
	static final String TEXTJSON="text/json";
	static final String TEXT_XML="text/xml";
	static final String AUTH_TEXT="Authorization";
	static final String ACCEPTTEXT="Accept";
	static final String CONTENTTYPE="Content-Type";
	static final String URLENCODE="application/x-www-form-urlencoded";
	static final String APIMETHOD="/api/login/";
	

    public LoginApi() {
        this(Configuration.getDefaultApiClient());
    }

    public LoginApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for loginADChangePwd
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginADChangePwdCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody13 = ldapUser;

        
        String localVarPath13 = APIMETHOD + "adchangepwd";

        List<Pair> localVarQueryParams13 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams13 = new ArrayList<>();

        Map<String, String> localVarHeaderParams13 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams13.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams13 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams13.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams13.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames13 = new String[] {  };
		BuildParameters buildParameters13=new BuildParameters();
			buildParameters13.setPath(localVarPath13);
			buildParameters13.setMethod("POST");
			buildParameters13.setQueryParams(localVarQueryParams13);
			buildParameters13.setCollectionQueryParams(localVarCollectionQueryParams13);
			buildParameters13.setBody(localVarPostBody13);
			buildParameters13.setHeaderParams(localVarHeaderParams13);
			buildParameters13.setFormParams(localVarFormParams13);
			buildParameters13.setAuthNames(localVarAuthNames13);
			buildParameters13.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters13);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginADChangePwdValidateBeforeCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'ldapUser' is set
        if (ldapUser == null) {
            throw new ApiException("Missing the required parameter 'ldapUser' when calling loginADChangePwd(Async)");
        }
        

        return loginADChangePwdCall(ldapUser, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginADChangePwd(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginADChangePwdWithHttpInfo(ldapUser, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginADChangePwdWithHttpInfo(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginADChangePwdValidateBeforeCall(ldapUser, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

	/**
     * Build call for loginADLogin
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginADLoginCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody23 = ldapUser;

        
        String localVarPath23 = APIMETHOD + "adlogin";

        List<Pair> localVarQueryParams23 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams23 = new ArrayList<>();

        Map<String, String> localVarHeaderParams23 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams23.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams23 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams23.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams23.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames23 = new String[] {  };
		BuildParameters buildParameters23=new BuildParameters();
			buildParameters23.setPath(localVarPath23);
			buildParameters23.setMethod("POST");
			buildParameters23.setQueryParams(localVarQueryParams23);
			buildParameters23.setCollectionQueryParams(localVarCollectionQueryParams23);
			buildParameters23.setBody(localVarPostBody23);
			buildParameters23.setHeaderParams(localVarHeaderParams23);
			buildParameters23.setFormParams(localVarFormParams23);
			buildParameters23.setAuthNames(localVarAuthNames23);
			buildParameters23.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters23);        
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginADLoginValidateBeforeCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'ldapUser' is set
        if (ldapUser == null) {
            throw new ApiException("Missing the required parameter 'ldapUser' when calling loginADLogin(Async)");
        }
        

        return loginADLoginCall(ldapUser, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginADLogin(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginADLoginWithHttpInfo(ldapUser, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginADLoginWithHttpInfo(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginADLoginValidateBeforeCall(ldapUser, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }
	/**
     * Build call for loginAddCreatUser
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginAddCreatUserCall(LDAPUser ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody33 = ldapUser;

        
        String localVarPath33 = APIMETHOD + "addcreatuser";

        List<Pair> localVarQueryParams33 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams33 = new ArrayList<>();

        Map<String, String> localVarHeaderParams33 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams33.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams33 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams33.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams33.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames33 = new String[] {  };
        BuildParameters buildParameters33=new BuildParameters();
			buildParameters33.setPath(localVarPath33);
			buildParameters33.setMethod("POST");
			buildParameters33.setQueryParams(localVarQueryParams33);
			buildParameters33.setCollectionQueryParams(localVarCollectionQueryParams33);
			buildParameters33.setBody(localVarPostBody33);
			buildParameters33.setHeaderParams(localVarHeaderParams33);
			buildParameters33.setFormParams(localVarFormParams33);
			buildParameters33.setAuthNames(localVarAuthNames33);
			buildParameters33.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters33);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginAddCreatUserValidateBeforeCall(LDAPUser ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'ldapUser' is set
        if (ldapUser == null) {
            throw new ApiException("Missing the required parameter 'ldapUser' when calling loginAddCreatUser(Async)");
        }
        

        return loginAddCreatUserCall(ldapUser, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginAddCreatUser(LDAPUser ldapUser, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginAddCreatUserWithHttpInfo(ldapUser, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginAddCreatUserWithHttpInfo(LDAPUser ldapUser, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginAddCreatUserValidateBeforeCall(ldapUser, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginAdresetPwd
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginAdresetPwdCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody43 = ldapUser;

        
        String localVarPath43 = APIMETHOD + "adresetpwd";

        List<Pair> localVarQueryParams43 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams43 = new ArrayList<>();

        Map<String, String> localVarHeaderParams43 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams43.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams43 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams43.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams43.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames43 = new String[] {  };
        BuildParameters buildParameters43=new BuildParameters();
			buildParameters43.setPath(localVarPath43);
			buildParameters43.setMethod("POST");
			buildParameters43.setQueryParams(localVarQueryParams43);
			buildParameters43.setCollectionQueryParams(localVarCollectionQueryParams43);
			buildParameters43.setBody(localVarPostBody43);
			buildParameters43.setHeaderParams(localVarHeaderParams43);
			buildParameters43.setFormParams(localVarFormParams43);
			buildParameters43.setAuthNames(localVarAuthNames43);
			buildParameters43.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters43);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginAdresetPwdValidateBeforeCall(LDAPLoginRequest ldapUser, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'ldapUser' is set
        if (ldapUser == null) {
            throw new ApiException("Missing the required parameter 'ldapUser' when calling loginAdresetPwd(Async)");
        }
        

        return loginAdresetPwdCall(ldapUser, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginAdresetPwd(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginAdresetPwdWithHttpInfo(ldapUser, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param ldapUser  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginAdresetPwdWithHttpInfo(LDAPLoginRequest ldapUser, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginAdresetPwdValidateBeforeCall(ldapUser, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginAuthenticate
     * @param login  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginAuthenticateCall(LoginRequest login, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody53 = login;

        
        String localVarPath53 = APIMETHOD + "authenticate";

        List<Pair> localVarQueryParams53 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams53 = new ArrayList<>();

        Map<String, String> localVarHeaderParams53 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams53.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams53 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams53.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams53.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames53 = new String[] {  };
        BuildParameters buildParameters53=new BuildParameters();
			buildParameters53.setPath(localVarPath53);
			buildParameters53.setMethod("POST");
			buildParameters53.setQueryParams(localVarQueryParams53);
			buildParameters53.setCollectionQueryParams(localVarCollectionQueryParams53);
			buildParameters53.setBody(localVarPostBody53);
			buildParameters53.setHeaderParams(localVarHeaderParams53);
			buildParameters53.setFormParams(localVarFormParams53);
			buildParameters53.setAuthNames(localVarAuthNames53);
			buildParameters53.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters53);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginAuthenticateValidateBeforeCall(LoginRequest login, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        if (login == null) {
            throw new ApiException("Missing the required parameter 'login' when calling loginAuthenticate(Async)");
        }
        return loginAuthenticateCall(login, authorization, progressListener, progressRequestListener);        
    }

    /**
     * 
     * 
     * @param login  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginAuthenticate(LoginRequest login, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginAuthenticateWithHttpInfo(login, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param login  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginAuthenticateWithHttpInfo(LoginRequest login, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginAuthenticateValidateBeforeCall(login, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginChangePwd
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginChangePwdCall(String id, CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody63 = value;
        String localVarPath63 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams63 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams63 = new ArrayList<>();

        Map<String, String> localVarHeaderParams63 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams63.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams63 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams63.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams63.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames63 = new String[] {  };
        BuildParameters buildParameters63=new BuildParameters();
			buildParameters63.setPath(localVarPath63);
			buildParameters63.setMethod("PUT");
			buildParameters63.setQueryParams(localVarQueryParams63);
			buildParameters63.setCollectionQueryParams(localVarCollectionQueryParams63);
			buildParameters63.setBody(localVarPostBody63);
			buildParameters63.setHeaderParams(localVarHeaderParams63);
			buildParameters63.setFormParams(localVarFormParams63);
			buildParameters63.setAuthNames(localVarAuthNames63);
			buildParameters63.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters63);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginChangePwdValidateBeforeCall(String id, CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling loginChangePwd(Async)");
        }
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling loginChangePwd(Async)");
        }
        return loginChangePwdCall(id, value, authorization, progressListener, progressRequestListener);

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginChangePwd(String id, CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginChangePwdWithHttpInfo(id, value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginChangePwdWithHttpInfo(String id, CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginChangePwdValidateBeforeCall(id, value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginDoc2signDocsTipos
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginDoc2signDocsTiposCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody73 = null;

        
        String localVarPath73 = APIMETHOD + "doc2signdocstipos";

        List<Pair> localVarQueryParams73 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams73 = new ArrayList<>();

        Map<String, String> localVarHeaderParams73 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams73.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams73 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams73.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams73.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames73 = new String[] {  };
        BuildParameters buildParameters73=new BuildParameters();
			buildParameters73.setPath(localVarPath73);
			buildParameters73.setMethod("POST");
			buildParameters73.setQueryParams(localVarQueryParams73);
			buildParameters73.setCollectionQueryParams(localVarCollectionQueryParams73);
			buildParameters73.setBody(localVarPostBody73);
			buildParameters73.setHeaderParams(localVarHeaderParams73);
			buildParameters73.setFormParams(localVarFormParams73);
			buildParameters73.setAuthNames(localVarAuthNames73);
			buildParameters73.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters73);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginDoc2signDocsTiposValidateBeforeCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return loginDoc2signDocsTiposCall(authorization, progressListener, progressRequestListener);
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginDoc2signDocsTipos(String authorization) throws ApiException {
        ApiResponse<Object> resp = loginDoc2signDocsTiposWithHttpInfo(authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginDoc2signDocsTiposWithHttpInfo(String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginDoc2signDocsTiposValidateBeforeCall(authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginDoc2signFirmantes
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginDoc2signFirmantesCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody83 = null;

        
        String localVarPath83 = APIMETHOD + "doc2signfirmantes";

        List<Pair> localVarQueryParams83 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams83 = new ArrayList<>();

        Map<String, String> localVarHeaderParams83 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams83.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams83 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams83.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams83.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames83 = new String[] {  };
        BuildParameters buildParameters83=new BuildParameters();
			buildParameters83.setPath(localVarPath83);
			buildParameters83.setMethod("POST");
			buildParameters83.setQueryParams(localVarQueryParams83);
			buildParameters83.setCollectionQueryParams(localVarCollectionQueryParams83);
			buildParameters83.setBody(localVarPostBody83);
			buildParameters83.setHeaderParams(localVarHeaderParams83);
			buildParameters83.setFormParams(localVarFormParams83);
			buildParameters83.setAuthNames(localVarAuthNames83);
			buildParameters83.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters83);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginDoc2signFirmantesValidateBeforeCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {        
        return loginDoc2signFirmantesCall(authorization, progressListener, progressRequestListener);        
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginDoc2signFirmantes(String authorization) throws ApiException {
        ApiResponse<Object> resp = loginDoc2signFirmantesWithHttpInfo(authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginDoc2signFirmantesWithHttpInfo(String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginDoc2signFirmantesValidateBeforeCall(authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Build call for loginFirmantes
     * @param firmante  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginFirmantesCall(CFirmante firmante, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = firmante;

        
        String localVarPath = APIMETHOD + "firmante";

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        BuildParameters buildParameters=new BuildParameters();
			buildParameters.setPath(localVarPath);
			buildParameters.setMethod("POST");
			buildParameters.setQueryParams(localVarQueryParams);
			buildParameters.setCollectionQueryParams(localVarCollectionQueryParams);
			buildParameters.setBody(localVarPostBody);
			buildParameters.setHeaderParams(localVarHeaderParams);
			buildParameters.setFormParams(localVarFormParams);
			buildParameters.setAuthNames(localVarAuthNames);
			buildParameters.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginFirmantesValidateBeforeCall(CFirmante firmante, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'firmante' is set
        if (firmante == null) {
            throw new ApiException("Missing the required parameter 'firmante' when calling loginFirmantes(Async)");
        }
        

        return loginFirmantesCall(firmante, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param firmante  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object loginFirmantes(CFirmante firmante, String authorization) throws ApiException {
        ApiResponse<Object> resp = loginFirmantesWithHttpInfo(firmante, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param firmante  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> loginFirmantesWithHttpInfo(CFirmante firmante, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = loginFirmantesValidateBeforeCall(firmante, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

}
